/* Output from p2c, the Pascal-to-C translator */
/* From input file "cht019.pp" */


/*#include <p2c/p2c.h>*/
typedef char Char;
typedef short boolean;
#define true 1
#define false 0
#define EXIT_SUCCESS 0
#define _Escape exit
#define P_argc argc
#define P_argv argv
#define strsub strstr
#define Malloc malloc
#define Static static
#define Void void
#include <stdio.h>   
#include <stdlib.h>
#include <string.h>
#include <ctype.h>



typedef struct TPoint {
  long X, Y, C, H, N, O, P, S, Si, B, Br, Cl, F, I, Na, K, RecCount;
  struct TPoint *Last;
} TPoint;


Static long C, H, N, O, P, S, Si, B, Br, Cl, F, I, Na, K, X1, X2, Y1, Y2, T;
Static FILE *IFile;
Static TPoint *Point, *Last, *Current;
Static Char sss[256], A[256], subs[256], Bondss[256], Labelss[256];
Static double M;
Static long Count, code, atoms, rep;
Static boolean Abandon, debug, verbose, exact, fa;


Static Void doBonds()
{
  Char *TEMP;
  Char STR2[256];

  fgets(sss, 256, IFile);
  TEMP = strchr(sss, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  do {
    if (debug)
      puts(sss);
/*      
    sprintf(STR2, "%.*s", strpos2(sss, "\t", 1) - 1, sss);
    code = (sscanf(STR2, "%ld", &X1) == 0);
    strcpy(sss, strsub(STR2, sss, strpos2(sss, "\t", 1) + 1,
		       (int)(strlen(sss) - strpos2(sss, "\t", 1) + 1L)));
    sprintf(STR2, "%.*s", strpos2(sss, "\t", 1) - 1, sss);
    code = (sscanf(STR2, "%ld", &Y1) == 0);
    strcpy(sss, strsub(STR2, sss, strpos2(sss, "\t", 1) + 1,
		       (int)(strlen(sss) - strpos2(sss, "\t", 1) + 1L)));
    sprintf(STR2, "%.*s", strpos2(sss, "\t", 1) - 1, sss);
    code = (sscanf(STR2, "%ld", &X2) == 0);
    strcpy(sss, strsub(STR2, sss, strpos2(sss, "\t", 1) + 1,
		       (int)(strlen(sss) - strpos2(sss, "\t", 1) + 1L)));
    sprintf(STR2, "%.*s", strpos2(sss, "\t", 1) - 1, sss);
    code = (sscanf(STR2, "%ld", &Y2) == 0);
    strcpy(sss, strsub(STR2, sss, strpos2(sss, "\t", 1) + 1,
		       (int)(strlen(sss) - strpos2(sss, "\t", 1) + 1L)));
    sprintf(STR2, "%.*s", strlen(sss), sss);
    code = (sscanf(STR2, "%ld", &T) == 0);
*/
	sscanf(sss,"%ld %ld %ld %ld %ld",&X1,&Y1,&X2,&Y2,&T);
	
    Abandon = false;
    Current = Point;
    while (Point->Last != NULL) {
      if ( abs(Point->X- X1)<3 && abs(Point->Y - Y1)<3) {
	if (debug)
	  printf("  %d --> Joined at %d %d\n",
		 Point->RecCount, X1, Y1);
	if (T == 0 || T == 5 || T == 6 || T == 7 || T == 10 || T == 13)
	  Point->H--;
	if (T == 1 || T == 2 || T == 4)
	  Point->H -= 2;
	if (T == 3)
	  Point->H -= 3;
	Abandon = true;
      }
      Point = Point->Last;
    }
    Point = Current;

    if (!Abandon) {
      Count++;
      Last = Point;
      Point = (TPoint *)Malloc(sizeof(TPoint));
      Point->X = X1;
      if (debug)
	printf(" Point^.X: %d", Point->X);
      Point->Y = Y1;
      if (debug)
	printf(" Point^.Y: %d", Point->Y);
      Point->C = 1;
      if (debug)
	printf(" Point^.C: %d", Point->C);
      if (T == 0 || T == 5 || T == 6 || T == 7 || T == 10 || T == 13)
	Point->H = 3;
      if (T == 1 || T == 2 || T == 4)
	Point->H = 2;
      if (T == 3)
	Point->H = 1;
      if (debug)
	printf(" Point^.H: %d", Point->H);
      Point->N = 0;
      Point->O = 0;
      Point->P = 0;
      Point->S = 0;
      Point->Si = 0;
      Point->B = 0;
      Point->Br = 0;
      Point->Cl = 0;
      Point->F = 0;
      Point->I = 0;
      Point->Na = 0;
      Point->K = 0;
      Point->RecCount = Count;
      if (debug)
	printf("Point^.RecCount: %d\n", Point->RecCount);
      Point->Last = Last;
    }

    Abandon = false;
    Current = Point;
    while (Point->Last != NULL) {
      if ( abs(Point->X- X2)<3 && abs(Point->Y -Y2)<3) {
	if (debug)
	  printf("  %d --> Joined at %d %d\n",
		 Point->RecCount, X2, Y2);
	if (T == 0 || T == 5 || T == 6 || T == 7 || T == 10 || T == 13)
	  Point->H--;
	if (T == 1 || T == 2 || T == 4)
	  Point->H -= 2;
	if (T == 3)
	  Point->H -= 3;
	Abandon = true;
      }
      Point = Point->Last;
    }
    Point = Current;

    if (!Abandon) {
      Count++;
      Last = Point;
      Point = (TPoint *)Malloc(sizeof(TPoint));
      Point->X = X2;
      if (debug)
	printf(" Point^.X: %d", Point->X);
      Point->Y = Y2;
      if (debug)
	printf(" Point^.Y: %d", Point->Y);
      Point->C = 1;
      if (debug)
	printf(" Point^.C: %d", Point->C);
      if (T == 0 || T == 5 || T == 6 || T == 7 || T == 10 || T == 13)
	Point->H = 3;
      if (T == 1 || T == 2 || T == 4)
	Point->H = 2;
      if (T == 3)
	Point->H = 1;
      if (debug)
	printf(" Point^.H: %d", Point->H);
      Point->N = 0;
      Point->O = 0;
      Point->P = 0;
      Point->S = 0;
      Point->Si = 0;
      Point->B = 0;
      Point->Br = 0;
      Point->Cl = 0;
      Point->F = 0;
      Point->I = 0;
      Point->Na = 0;
      Point->K = 0;
      Point->RecCount = Count;
      if (debug)
	printf("Point^.RecCount: %d\n", Point->RecCount);
      Point->Last = Last;
    }

    fgets(sss, 256, IFile);
    TEMP = strchr(sss, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
  } while (isdigit(sss[0]));
}


Static Void doLabels()
{
  long mul, gmul, gmpos, ggmul, ggmpos, code;
  Char STR1[256];
  Char STR2[256];
  long FORLIM;
  Char *TEMP;

  if (debug)
    printf("---- and now parse the labels ---------\n");
/*  sprintf(STR2, "%.*s", strpos2(sss, " ", 1) - 1, sss);
  if (!strcmp(STR2, "atoms")) {
    code = (sscanf(strsub(STR1, sss, strpos2(sss, " ", 1),
			  (int)(strlen(sss) - strpos2(sss, " ", 1) + 1L)),
		   "%ld", &atoms) == 0);
 */
 if (debug)printf("###%s###\n",sss);
 sscanf(sss,"%*s %ld",&atoms);
    if (verbose)
      printf("HeteroAtoms: %d\n", atoms);
/*  }*/
  FORLIM = atoms;
  for (rep = 1; rep <= FORLIM; rep++) {
    fgets(sss, 256, IFile);
    TEMP = strchr(sss, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
    /*
    sprintf(STR2, "%.*s", strpos2(sss, "\t", 1) - 1, sss);
    code = (sscanf(STR2, "%ld", &X1) == 0);
    strcpy(sss, strsub(STR2, sss, strpos2(sss, "\t", 1) + 1,
		       (int)(strlen(sss) - strpos2(sss, "\t", 1) + 1L)));
    sprintf(STR2, "%.*s", strpos2(sss, "\t", 1) - 1, sss);
    code = (sscanf(STR2, "%ld", &Y1) == 0);
    strcpy(sss, strsub(STR2, sss, strpos2(sss, "\t", 1) + 1,
		       (int)(strlen(sss) - strpos2(sss, "\t", 1) + 1L)));
    sprintf(A, "%.*s", strpos2(sss, "\t", 1) - 1, sss);
*/
	sscanf(sss,"%ld %ld %s",&X1,&Y1,A);
    if (debug)
      printf("Atom %s X=%d Y=%d sss: %s\n", A, X1, Y1, sss);
    Current = Point;
    while (Point->Last != NULL) {
      if ( abs(Point->X -X1)<3 && abs(Point->Y - Y1)<3) {
	if (debug)
	  printf("  %d --> Heteroatom %d %d\n",
		 Point->RecCount, X1, Y1);
	Point->C = 0;   /*we substitute -CH_x(-) by -R(-)*/
	Point->H = 0;
	mul = 1;
	gmul = 1;
	ggmul = 1;
	gmpos = 0;
	ggmpos = 0;
	while (*A != '\0') {
	if (debug)printf("...%s...",A);
	  if (strlen(A) >= 5) {
	    sprintf(subs, "%.5s", A);
	    if (strlen(A) > 6) {
	      if (A[5] == '_') {
		sprintf(STR2, "%c", A[6]);
		code = (sscanf(STR2, "%ld", &mul) == 0);
	      } else
		mul = 1;
	    }
	    mul *= gmul * ggmul;
	    if (!strcmp(subs, "TBDMS")) {  /*Tert-butyldimethylsilyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 6;
	      Point->H += mul * 15;
	      Point->Si += mul;
/*	      strcpy(A, strsub(STR1, A, 6, (int)(strlen(A) - 5L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+5, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "TBDPS")) {  /*Tert-butyldiphenylsilyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 16;
	      Point->H += mul * 19;
	      Point->Si += mul;
/*	      strcpy(A, strsub(STR2, A, 6, (int)(strlen(A) - 5L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+5, (int)(strlen(STR1)));
	    }
	    if (A[0] == '[') {
/*	      ggmpos = strpos2(A, "]", 1);*/
	      ggmpos = (int)index(A, ']');
	      if (ggmpos != 0) {
		if (A[ggmpos] == '_') {
		  sprintf(STR2, "%c", A[ggmpos + 1]);
		  code = (sscanf(STR2, "%ld", &ggmul) == 0);
		} else
		  ggmul = 1;
	      }
	    }
	    if (A[0] == '(') {
/*	      gmpos = strpos2(A, ")", 1);*/
	      gmpos = (int) index(A, ')');
	      if (gmpos != 0) {
		if (A[gmpos] == '_') {
		  sprintf(STR2, "%c", A[gmpos + 1]);
		  code = (sscanf(STR2, "%ld", &gmul) == 0);
		} else
		  gmul = 1;
	      }
	    }
	  }
	  if (strlen(A) >= 4) {
	    sprintf(subs, "%.4s", A);
	    if (strlen(A) > 5) {
	      if (A[4] == '_') {
		sprintf(STR2, "%c", A[5]);
		code = (sscanf(STR2, "%ld", &mul) == 0);
	      } else
		mul = 1;
	    }
	    mul *= gmul * ggmul;
	    if (!strcmp(subs, "DBAM"))
	    {  /*dibutylaminomethylene; =R, used as the N prot.*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 9;
	      Point->H += mul * 19;
	      Point->N += mul;
/*	      strcpy(A, strsub(STR1, A, 5, (int)(strlen(A) - 4L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+4, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "DMAM"))
	    {  /*dimethylaminomethylene; =R, used as the N prot.*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 3;
	      Point->H += mul * 7;
	      Point->N += mul;
/*	      strcpy(A, strsub(STR2, A, 5, (int)(strlen(A) - 4L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+4, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "DMTr")) {  /*dimethoxytrityl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 21;
	      Point->H += mul * 19;
	      Point->O += mul * 2;
/*	      strcpy(A, strsub(STR1, A, 5, (int)(strlen(A) - 4L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+4, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "MMTr")) {  /*monomethoxytrityl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 20;
	      Point->H += mul * 16;
	      Point->O += mul;
/*	      strcpy(A, strsub(STR2, A, 5, (int)(strlen(A) - 4L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+4, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "TMTr")) {  /*trimethoxytrityl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 22;
	      Point->H += mul * 22;
	      Point->O += mul * 3;
/*	      strcpy(A, strsub(STR1, A, 5, (int)(strlen(A) - 4L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+4, (int)(strlen(STR1)));
	    }
	  }
	  if (strlen(A) >= 3) {
	    sprintf(subs, "%.3s", A);
	    if (strlen(A) > 4) {
	      if (A[3] == '_') {
		sprintf(STR1, "%c", A[4]);
		code = (sscanf(STR1, "%ld", &mul) == 0);
	      } else
		mul = 1;
	    }
	    mul *= gmul * ggmul;
	    if (!strcmp(subs, "Ade")) {  /*Adeninyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 5;
	      Point->H += mul * 4;
	      Point->N += mul * 5;
/*	      strcpy(A, strsub(STR2, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));

	    }
	    if (!strcmp(subs, "BOC")) {  /*Butyloxycarbonyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 5;
	      Point->H += mul * 9;
	      Point->O += mul * 2;
/*	      strcpy(A, strsub(STR1, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "Cyt")) {  /*Cytosinyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 4;
	      Point->H += mul * 4;
	      Point->N += mul * 3;
	      Point->O += mul;
/*	      strcpy(A, strsub(STR2, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "Gua")) {  /*Guaninyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 5;
	      Point->H += mul * 4;
	      Point->N += mul * 5;
	      Point->O += mul;
/*	      strcpy(A, strsub(STR1, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "iBu")) {  /*iso-Butyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 4;
	      Point->H += mul * 9;
/*	      strcpy(A, strsub(STR2, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "iPr")) {  /*2-Propyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 3;
	      Point->H += mul * 7;
/*	      strcpy(A, strsub(STR1, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "MOC")) {  /*Methoxycarbonyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 2;
	      Point->H += mul * 3;
	      Point->O += mul * 2;
/*	      strcpy(A, strsub(STR2, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "MOM")) {  /*Methoxymethyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 2;
	      Point->H += mul * 5;
	      Point->O += mul;
/*	      strcpy(A, strsub(STR1, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "tBu")) {  /*t-Butyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 4;
	      Point->H += mul * 9;
/*	      strcpy(A, strsub(STR2, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "Thy")) {  /*Thyminyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 5;
	      Point->H += mul * 5;
	      Point->N += mul * 2;
	      Point->O += mul * 2;
/*	      strcpy(A, strsub(STR1, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "TMS")) {  /*Trimethylsilyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 3;
	      Point->H += mul * 9;
	      Point->Si += mul;
/*	      strcpy(A, strsub(STR2, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "Tol")) {  /*tolyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 8;
	      Point->H += mul * 7;
	      Point->O += mul;
/*	      strcpy(A, strsub(STR1, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "Ura")) {  /*Uracilyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 4;
	      Point->H += mul * 3;
	      Point->N += mul * 2;
	      Point->O += mul * 2;
/*	      strcpy(A, strsub(STR2, A, 4, (int)(strlen(A) - 3L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+3, (int)(strlen(STR1)));
	    }
	  }
	  if (strlen(A) >= 2) {
	    sprintf(subs, "%.2s", A);
	    if (strlen(A) > 3) {
	      if (A[2] == '_') {
		sprintf(STR2, "%c", A[3]);
		code = (sscanf(STR2, "%ld", &mul) == 0);
	      } else
		mul = 1;
	    } /*else if (A[0]=='_') break;*/ /****/
	    mul *= gmul * ggmul;
	    if (!strcmp(subs, "Ac")) {  /*acetyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul;
	      Point->H += mul * 3;
/*	      strcpy(A, strsub(STR1, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "Bn")) {  /*benzyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 7;
	      Point->H += mul * 7;
/*	      strcpy(A, strsub(STR2, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "Br")) {  /*bromine*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->Br += mul;
/*	      strcpy(A, strsub(STR1, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+2, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "Bu")) {  /*butyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 4;
	      Point->H += mul * 9;
/*	      strcpy(A, strsub(STR2, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+2, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "Bz")) {  /*benzoyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 7;
	      Point->H += mul * 5;
	      Point->O += mul;
/*	      strcpy(A, strsub(STR1, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "CE")) {  /*cyanoethyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 3;
	      Point->H += mul * 4;
	      Point->N += mul;
/*	      strcpy(A, strsub(STR2, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "Cl")) {  /*chlorine*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->Cl += mul;
/*	      strcpy(A, strsub(STR1, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "Et")) {  /*ethyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 2;
	      Point->H += mul * 5;
/*	      strcpy(A, strsub(STR2, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+2, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "Me")) {  /*methyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul;
	      Point->H += mul * 3;
/*	      strcpy(A, strsub(STR1, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+2, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "Ms")) {  /*methanesulfonyl, mesyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul;
	      Point->H += mul * 3;
	      Point->O += mul * 2;
	      Point->S += mul;
/*	      strcpy(A, strsub(STR2, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "Na")) {  /*sodium*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->Na += mul;
/*	      strcpy(A, strsub(STR1, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "Ph")) {  /*phenyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 6;
	      Point->H += mul * 5;
/*	      strcpy(A, strsub(STR2, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "Pr")) {  /*propyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 3;
	      Point->H += mul * 7;
/*	      strcpy(A, strsub(STR1, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+2, (int)(strlen(STR1)));
	    }
	    if (!strcmp(subs, "Tf")) {  /*trifluoromethanesulfonyl, triflyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul;
	      Point->F += mul * 3;
	      Point->O += mul * 2;
	      Point->S += mul;
/*	      strcpy(A, strsub(STR2, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "Tr")) {  /*trityl, triphenylmethyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 19;
	      Point->H += mul * 15;
/*	      strcpy(A, strsub(STR1, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "Ts")) {  /*toluenesulfonyl, tosyl*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->C += mul * 7;
	      Point->H += mul * 7;
	      Point->O += mul * 2;
	      Point->S += mul;
/*	      strcpy(A, strsub(STR2, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
	    }
	    if (!strcmp(subs, "Si")) {  /*silicon*/
	      if (debug)
		printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	      Point->Si += mul;
/*	      strcpy(A, strsub(STR1, A, 3, (int)(strlen(A) - 2L)));*/
	      strcpy(STR1,A);
	      strcpy(A, (char*)STR1+2);
              
	    }
	  }
	  if (strlen(A) < 1)
	    continue;
	  sprintf(subs, "%.1s", A);
	  if (strlen(A) > 2) {
	    if (A[1] == '_') {
	      sprintf(STR1, "%c", A[2]);
	      code = (sscanf(STR1, "%ld", &mul) == 0);
	    } else
	      mul = 1;
	  }
	  mul *= gmul * ggmul;
	  if (!strcmp(subs, "B")) {  /*boron*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->B += mul;
/*	    strcpy(A, strsub(STR2, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1)));
	  }
	  if (!strcmp(subs, "C")) {  /*carbon*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->C += mul;
/*	    strcpy(A, strsub(STR1, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1)));
	  }
	  if (!strcmp(subs, "F")) {  /*fluorine*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->F += mul;
/*	    strcpy(A, strsub(STR2, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1) - 1L));
	  }
	  if (!strcmp(subs, "H")) {  /*hydrogen*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->H += mul;
/*	    strcpy(A, strsub(STR1, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1)));
		strcat(A,"\0");
	  }
	  if (!strcmp(subs, "I")) {  /*iodine*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->I += mul;
/*	    strcpy(A, strsub(STR2, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1) - 1L));
	  }
	  if (!strcmp(subs, "K")) {  /*potassium*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->K += mul;
/*	    strcpy(A, strsub(STR1, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1) - 1L));
	  }
	  if (!strcmp(subs, "N")) {  /*nitrogen*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->N += mul;
/*	    strcpy(A, strsub(STR2, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1)));
	  }
	  if (!strcmp(subs, "O")) {  /*oxygen*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->O += mul;
/*	    strcpy(A, strsub(STR1, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1)));
	  }
	  if (!strcmp(subs, "P")) {  /*phosphorus*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->P += mul;
/*	    strcpy(A, strsub(STR2, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1)));
	  }
	  if (!strcmp(subs, "S")) {  /*sulfur*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->S += mul;
/*	    strcpy(A, strsub(STR1, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1) - 1L));
	  }
	  if (!strcmp(subs, "Z")) {  /*"Z", Benzyloxycarbonyl*/
	    if (debug)
	      printf("%s*%d (%d,%d)\n", subs, mul, gmul, ggmul);
	    Point->C += mul * 8;
	    Point->H += mul * 7;
	    Point->O += mul * 2;
/*	    strcpy(A, strsub(STR2, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
	      strncpy(A, (char*)STR1+1, (int)(strlen(STR1) - 1L));
	  }
	  if (!strcmp(subs, ")"))  /*reset gmul*/
	    gmul = 1;
	  if (!strcmp(subs, "]")) {  /*reset gmul,ggmul*/
	    gmul = 1;
	    ggmul = 1;
	  }
	  if (subs[0] < 'B' || subs[0] > 'Z')
/*	    strcpy(A, strsub(STR2, A, 2, (int)(strlen(A) - 1L)));*/
	      strcpy(STR1,A);
/*	fprintf(stderr,"???%s???\n",A);*/
	      strcpy(A, (char*)STR1+1);
/*	fprintf(stderr,"!!!%s!!!\n",A);*/
	}
      }
      Point = Point->Last;
    }
    Point = Current;
  }
}


main(argc, argv)
int argc;
Char *argv[];
{
  Char STR1[256], STR2[256];
  Char *TEMP;

/*  PASCAL_MAIN(argc, argv);*/
  IFile = NULL;
  if (P_argc == 1) {
    printf("enter \"cht -h\" for help\n");
    _Escape(0);
  }
  C = 0;
  H = 0;
  N = 0;
  O = 0;
  P = 0;
  S = 0;
  Si = 0;
  B = 0;
  Br = 0;
  I = 0;
  Cl = 0;
  F = 0;
  Na = 0;
  K = 0;
  verbose = false;
  debug = false;
  exact = false;
  fa = false;   /*no file assigned*/
  Count = 0;
  for (rep = 1; rep < P_argc; rep++) {
    if ((strcmp(strcpy(STR2, P_argv[rep]), "-v") == 0) |
	(strcmp(strcpy(STR1, P_argv[rep]), "--verbose") == 0))
      verbose = true;
    if ((strcmp(strcpy(STR2, P_argv[rep]), "-d") == 0) |
	(strcmp(strcpy(STR1, P_argv[rep]), "--debug") == 0))
      debug = true;
    if ((strcmp(strcpy(STR2, P_argv[rep]), "-e") == 0) |
	(strcmp(strcpy(STR1, P_argv[rep]), "--exact") == 0))
      exact = true;
    if ((strcmp(strcpy(STR2, P_argv[rep]), "-h") == 0) |
	(strcmp(strcpy(STR1, P_argv[rep]), "--help") == 0)) {
      printf("The Chemtool drawings analyzer 0.19\n");
      printf("***   Gizmo Head Software   ***\n");
      printf("    Radek Liboska (c) 2000\n\n");
      printf("syntax: cht [-options] <filename.cht>\n\n");
      printf("Recognize C,H,O,N,P,S,Si,B,Br,I,Cl,F,Na,K\n");
      printf(
	"          Ac,Ade,Bn,Bu,Bz,BOC,Cyt,CE,DBAM,DMAM,DMTr,Et,Gua,iBu,iPr,Me,Ms,MOC,MOM,MMTr\n");
      printf("          Ph,Pr,tBu,Tf,Thy,Tol,Tr,Ts,TBDMS,TBDPS,TMS,TMTr,Ura,Z\n");
      printf("Can handle two levels of patentheses; e.g. P[OCH(CH_3)_2]_3\n\n");
      printf("options:\n");
      printf("  -h or --help : this help\n");
      printf("  -e or --exact: calculate exact mass for MS\n");
      printf("  -v or --verbose : be verbose\n");
      printf("  -d or --debug : be more verbose\n\n");
      _Escape(0);
    }
    if (strcpy(STR2, P_argv[rep])[0] != '-') {
      /*assign(IFile, strcpy(STR1, P_argv[rep]));*/
     IFile=fopen(P_argv[rep],"r");
      fa = true;
    }
/* p2c: cht019.pp, line 624: Warning:
 * Don't know how to ASSIGN to a non-explicit file variable [207] */
  }
  if (!fa) {
    printf("No file defined,  enter \"cht -h\" for help\n");
    _Escape(1);
  }
  rewind(IFile);
  Point = (TPoint *)Malloc(sizeof(TPoint));
  Point->X = 0;
  Point->Y = 0;
  Point->C = 0;
  Point->H = 0;
  Point->N = 0;
  Point->O = 0;
  Point->P = 0;
  Point->S = 0;
  Point->Si = 0;
  Point->B = 0;
  Point->Br = 0;
  Point->Cl = 0;
  Point->F = 0;
  Point->I = 0;
  Point->Na = 0;
  Point->K = 0;
  Point->RecCount = Count;
  Point->Last = NULL;
  fgets(sss, 256, IFile);
  TEMP = strchr(sss, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  if (strncmp(sss, "Chemtool Version 1.",18)) {
    printf("Not a chemtool 1.x file,  enter \"cht -h\" for help\n");
    _Escape(2);
  }
  fscanf(IFile, "%*[^\n]");
  getc(IFile);
  fgets(sss, 256, IFile);
  TEMP = strchr(sss, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
/*  strsub(Bondss, sss, 7, strlen(sss));
  if (sss[6] != '0')*/
  if (!strncmp(sss,"bonds",5) && sss[6]!='0')
    doBonds();
  else
    printf("we do not calculate labels with no connection to any bond\n");
/*  strsub(Labelss, sss, 7, strlen(sss));
  if (sss[6] != '0')*/
  if (!strncmp(sss,"atoms",5))
    doLabels();


  if (IFile != NULL)
    fclose(IFile);
  IFile = NULL;
  if (verbose)
    printf("---------------------- Summary -------------------------\n");
  while (Point->Last != NULL) {
    if (verbose)
      printf(
	"RecCount: %d X=%d Y=%d C%d H%d N%d O%d P%d S%d Si%d B%d Br%d Cl%d F%d I%d Na%d K%d\n",
	Point->RecCount, Point->X, Point->Y, Point->C, Point->H, Point->N,
	Point->O, Point->P, Point->S, Point->Si, Point->B, Point->Br,
	Point->Cl, Point->F, Point->I, Point->Na, Point->K);
    C += Point->C;
    H += Point->H;
    N += Point->N;
    O += Point->O;
    P += Point->P;
    S += Point->S;
    Si += Point->Si;
    B += Point->B;
    Br += Point->Br;
    Cl += Point->Cl;
    F += Point->F;
    I += Point->I;
    Na += Point->Na;
    K += Point->K;

    Point = Point->Last;
  }
  if (C > 1)
    printf("C%d", C);
  if (C == 1)
    putchar('C');
  if (H > 1)
    printf("H%d", H);
  if (H == 1)
    putchar('H');
  if (N > 1)
    printf("N%d", N);
  if (N == 1)
    putchar('N');
  if (O > 1)
    printf("O%d", O);
  if (O == 1)
    putchar('O');
  if (P > 1)
    printf("P%d", P);
  if (P == 1)
    putchar('P');
  if (S > 1)
    printf("S%d", S);
  if (S == 1)
    putchar('S');
  if (Si > 1)
    printf("Si%d", Si);
  if (Si == 1)
    printf("Si");
  if (B > 1)
    printf("B%d", B);
  if (B == 1)
    putchar('B');
  if (Br > 1)
    printf("Br%d", Br);
  if (Br == 1)
    printf("Br");
  if (Cl > 1)
    printf("Cl%d", Cl);
  if (Cl == 1)
    printf("Cl");
  if (F > 1)
    printf("F%d", F);
  if (F == 1)
    putchar('F');
  if (I > 1)
    printf("I%d", I);
  if (I == 1)
    putchar('I');
  if (Na > 1)
    printf("Na%d", Na);
  if (Na == 1)
    printf("Na");
  if (K > 1)
    printf("K%d", K);
  if (K == 1)
    putchar('K');

  if (exact) {
    M = C * 12 + H * 1.007825037 + N * 14.003074008 + O * 15.99491464 +
	P * 30.9737634 + S * 31.9720718 + Si * 27.9769284 + B * 11.0093053 +
	Br * 78.9183361 + Cl * 34.968852729 + F * 18.99840325 +
	I * 126.904477 + Na * 22.9897697 + K * 38.9637079;
    printf(" [%2.10f]\n", M);
  } else {
    M = C * 12.011 + H * 1.0079 + N * 14.0067 + O * 15.9994 + P * 30.9738 +
	S * 32.064 + Si * 28.086 + B * 79.90 + Br * 79.90 + Cl * 35.453 +
	F * 18.9984 + I * 126.9045 + Na * 22.9898 + K * 39.10;
    printf(" [%2.3f]", M);

    M = C * 12 + H * 1.007825037 + N * 14.003074008 + O * 15.99491464 +
	P * 30.9737634 + S * 31.9720718 + Si * 27.9769284 + B * 11.0093053 +
	Br * 78.9183361 + Cl * 34.968852729 + F * 18.99840325 +
	I * 126.904477 + Na * 22.9897697 + K * 38.9637079;
    printf(" (me=%2.10f)\n", M);

    /*Writeln('; ',Bondss,' bonds; ',Labelss,' labels.');*/
  }
  if (IFile != NULL)
    fclose(IFile);
  exit(EXIT_SUCCESS);
}



/* End. */
